/* Utilities.c generated by valac 0.56.17, the Vala compiler
 * generated from Utilities.vala, do not modify */

/*
 * Plotinus - A searchable command palette in every modern GTK+ application
 *
 * Copyright (c) 2016-2017 Philipp Emanuel Weidmann <pew@worldwidemann.com>
 *
 * Nemo vir est qui mundum non reddat meliorem.
 *
 * Released under the terms of the GNU General Public License, version 3
 * (https://gnu.org/licenses/gpl.html)
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <glib-object.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gchar* (*PlotinusUtilitiesMapFunction) (const gchar* element, gpointer user_data);
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block15Data Block15Data;

#define PLOTINUS_TYPE_POPUP_WINDOW (plotinus_popup_window_get_type ())
#define PLOTINUS_POPUP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLOTINUS_TYPE_POPUP_WINDOW, PlotinusPopupWindow))
#define PLOTINUS_POPUP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLOTINUS_TYPE_POPUP_WINDOW, PlotinusPopupWindowClass))
#define PLOTINUS_IS_POPUP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLOTINUS_TYPE_POPUP_WINDOW))
#define PLOTINUS_IS_POPUP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLOTINUS_TYPE_POPUP_WINDOW))
#define PLOTINUS_POPUP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLOTINUS_TYPE_POPUP_WINDOW, PlotinusPopupWindowClass))

typedef struct _PlotinusPopupWindow PlotinusPopupWindow;
typedef struct _PlotinusPopupWindowClass PlotinusPopupWindowClass;

struct _Block15Data {
	int _ref_count_;
	GtkWindow** windows;
	gint windows_length1;
	gint _windows_size_;
};

VALA_EXTERN gchar** plotinus_utilities_map_string (gchar** array,
                                       gint array_length1,
                                       PlotinusUtilitiesMapFunction map_function,
                                       gpointer map_function_target,
                                       gint* result_length1);
static void _vala_array_add23 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
VALA_EXTERN gboolean plotinus_utilities_contains_words (const gchar* text,
                                            gchar** words,
                                            gint words_length1,
                                            gboolean require_all);
VALA_EXTERN gchar* plotinus_utilities_highlight_words (const gchar* text,
                                           gchar** words,
                                           gint words_length1,
                                           const gchar* markup_tag);
static gchar* __lambda10_ (const gchar* word);
static gchar* ___lambda10__plotinus_utilities_map_function (const gchar* element,
                                                     gpointer self);
VALA_EXTERN gchar* plotinus_utilities_format_accelerator (const gchar* accelerator);
VALA_EXTERN gchar* plotinus_utilities_clean_label (const gchar* label);
VALA_EXTERN GtkWidget* plotinus_utilities_find_widget (GtkContainer* container,
                                           GType widget_type);
VALA_EXTERN gchar* plotinus_utilities_get_button_label (GtkButton* button);
VALA_EXTERN gchar* plotinus_utilities_get_window_title (GtkWindow* window);
VALA_EXTERN GtkWindow** plotinus_utilities_get_windows (gint* result_length1);
static Block15Data* block15_data_ref (Block15Data* _data15_);
static void block15_data_unref (void * _userdata_);
static void __lambda18_ (Block15Data* _data15_,
                  GtkWindow* window);
VALA_EXTERN GType plotinus_popup_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PlotinusPopupWindow, g_object_unref)
static void _vala_array_add24 (GtkWindow** * array,
                        gint* length,
                        gint* size,
                        GtkWindow* value);
static void ___lambda18__gfunc (gconstpointer data,
                         gpointer self);
static GtkWindow** _vala_array_dup13 (GtkWindow** self,
                               gssize length);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static GRegex* _tmp_regex_0 = NULL;

static void
_vala_array_add23 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if ((*length) == (*size)) {
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 128 "Utilities.c"
	}
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	(*array)[(*length)++] = value;
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	(*array)[*length] = NULL;
#line 134 "Utilities.c"
}

gchar**
plotinus_utilities_map_string (gchar** array,
                               gint array_length1,
                               PlotinusUtilitiesMapFunction map_function,
                               gpointer map_function_target,
                               gint* result_length1)
{
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** result;
#line 19 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 19 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_result_ = _tmp0_;
#line 19 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_result__length1 = 0;
#line 19 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	__result__size_ = _result__length1;
#line 159 "Utilities.c"
	{
		gchar** element_collection = NULL;
		gint element_collection_length1 = 0;
		gint _element_collection_size_ = 0;
		gint element_it = 0;
#line 20 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		element_collection = array;
#line 20 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		element_collection_length1 = array_length1;
#line 20 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		for (element_it = 0; element_it < element_collection_length1; element_it = element_it + 1) {
#line 171 "Utilities.c"
			gchar* _tmp1_;
			gchar* element = NULL;
#line 20 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp1_ = g_strdup (element_collection[element_it]);
#line 20 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			element = _tmp1_;
#line 178 "Utilities.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_;
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp2_ = element;
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp3_ = map_function (_tmp2_, map_function_target);
#line 21 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_vala_array_add23 (&_result_, &_result__length1, &__result__size_, _tmp3_);
#line 20 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_g_free0 (element);
#line 190 "Utilities.c"
			}
		}
	}
#line 23 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp4_ = _result_;
#line 23 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp4__length1 = _result__length1;
#line 23 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (result_length1) {
#line 23 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		*result_length1 = _tmp4__length1;
#line 202 "Utilities.c"
	}
#line 23 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp4_;
#line 23 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 208 "Utilities.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 227 "Utilities.c"
}

gboolean
plotinus_utilities_contains_words (const gchar* text,
                                   gchar** words,
                                   gint words_length1,
                                   gboolean require_all)
{
	gboolean result;
#line 26 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 239 "Utilities.c"
	{
		gchar** word_collection = NULL;
		gint word_collection_length1 = 0;
		gint _word_collection_size_ = 0;
		gint word_it = 0;
#line 27 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		word_collection = words;
#line 27 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		word_collection_length1 = words_length1;
#line 27 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		for (word_it = 0; word_it < word_collection_length1; word_it = word_it + 1) {
#line 251 "Utilities.c"
			gchar* _tmp0_;
			gchar* word = NULL;
#line 27 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp0_ = g_strdup (word_collection[word_it]);
#line 27 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			word = _tmp0_;
#line 258 "Utilities.c"
			{
				const gchar* _tmp1_;
#line 28 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp1_ = word;
#line 28 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				if (string_contains (text, _tmp1_)) {
#line 29 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					if (!require_all) {
#line 30 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						result = TRUE;
#line 30 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_g_free0 (word);
#line 30 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						return result;
#line 273 "Utilities.c"
					}
				} else {
#line 31 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					if (require_all) {
#line 32 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						result = FALSE;
#line 32 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_g_free0 (word);
#line 32 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						return result;
#line 284 "Utilities.c"
					}
				}
#line 27 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_g_free0 (word);
#line 289 "Utilities.c"
			}
		}
	}
#line 36 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = require_all;
#line 36 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 297 "Utilities.c"
}

static gchar*
__lambda10_ (const gchar* word)
{
	gchar* _tmp0_;
	gchar* result;
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (word != NULL, NULL);
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = g_regex_escape_string (word, -1);
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 313 "Utilities.c"
}

static gchar*
___lambda10__plotinus_utilities_map_function (const gchar* element,
                                              gpointer self)
{
	gchar* result;
	result = __lambda10_ (element);
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 324 "Utilities.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 338 "Utilities.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 342 "Utilities.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 348 "Utilities.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 353 "Utilities.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 359 "Utilities.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 363 "Utilities.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 367 "Utilities.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 371 "Utilities.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 375 "Utilities.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 379 "Utilities.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 394 "Utilities.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 403 "Utilities.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 410 "Utilities.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 416 "Utilities.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 424 "Utilities.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 428 "Utilities.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 434 "Utilities.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 439 "Utilities.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 445 "Utilities.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 449 "Utilities.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 453 "Utilities.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 459 "Utilities.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 465 "Utilities.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 477 "Utilities.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 481 "Utilities.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 485 "Utilities.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 490 "Utilities.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 498 "Utilities.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 516 "Utilities.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 522 "Utilities.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 526 "Utilities.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 534 "Utilities.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 543 "Utilities.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 552 "Utilities.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 558 "Utilities.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 566 "Utilities.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 578 "Utilities.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 584 "Utilities.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 588 "Utilities.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 596 "Utilities.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 607 "Utilities.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 616 "Utilities.c"
	}
}

gchar*
plotinus_utilities_highlight_words (const gchar* text,
                                    gchar** words,
                                    gint words_length1,
                                    const gchar* markup_tag)
{
	gchar** regex_words = NULL;
	gint _tmp1_ = 0;
	gchar** _tmp2_;
	gint regex_words_length1;
	gint _regex_words_size_;
	GRegex* regex = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GRegex* _tmp10_;
	GRegex* _tmp11_;
	GString* builder = NULL;
	GString* _tmp12_;
	GRegex* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	GString* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 41 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 41 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (markup_tag != NULL, NULL);
#line 42 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (words_length1 == 0) {
#line 658 "Utilities.c"
		gchar* _tmp0_;
#line 43 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp0_ = g_markup_escape_text (text, (gssize) -1);
#line 43 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = _tmp0_;
#line 43 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 666 "Utilities.c"
	}
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp2_ = plotinus_utilities_map_string (words, (gint) words_length1, ___lambda10__plotinus_utilities_map_function, NULL, &_tmp1_);
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	regex_words = _tmp2_;
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	regex_words_length1 = _tmp1_;
#line 45 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_regex_words_size_ = regex_words_length1;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp3_ = regex_words;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp3__length1 = regex_words_length1;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp4_ = _vala_g_strjoinv ("|", _tmp3_, (gint) _tmp3__length1);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp5_ = _tmp4_;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp6_ = g_strconcat ("(", _tmp5_, NULL);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp7_ = _tmp6_;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp9_ = _tmp8_;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp10_ = g_regex_new (_tmp9_, G_REGEX_CASELESS, 0, &_inner_error0_);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp11_ = _tmp10_;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_free0 (_tmp9_);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_free0 (_tmp7_);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_free0 (_tmp5_);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	regex = _tmp11_;
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		regex_words = (_vala_array_free (regex_words, regex_words_length1, (GDestroyNotify) g_free), NULL);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_clear_error (&_inner_error0_);
#line 48 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return NULL;
#line 714 "Utilities.c"
	}
#line 50 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp12_ = g_string_new ("");
#line 50 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	builder = _tmp12_;
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp13_ = regex;
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp15_ = _tmp14_ = g_regex_split (_tmp13_, text, 0);
#line 724 "Utilities.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		part_collection = _tmp15_;
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		part_collection_length1 = _vala_array_length (_tmp14_);
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 736 "Utilities.c"
			gchar* _tmp16_;
			gchar* part = NULL;
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp16_ = g_strdup (part_collection[part_it]);
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			part = _tmp16_;
#line 743 "Utilities.c"
			{
				gchar* part_markup = NULL;
				const gchar* _tmp17_;
				gchar* _tmp18_;
				GRegex* _tmp19_;
				const gchar* _tmp20_;
#line 56 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp17_ = part;
#line 56 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp18_ = g_markup_escape_text (_tmp17_, (gssize) -1);
#line 56 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				part_markup = _tmp18_;
#line 61 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp19_ = regex;
#line 61 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp20_ = part;
#line 61 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				if (g_regex_match (_tmp19_, _tmp20_, 0, NULL)) {
#line 762 "Utilities.c"
					GString* _tmp21_;
					GString* _tmp22_;
					GString* _tmp23_;
					GString* _tmp24_;
					const gchar* _tmp25_;
					GString* _tmp26_;
					GString* _tmp27_;
					GString* _tmp28_;
#line 62 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp21_ = builder;
#line 62 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp22_ = g_string_append (_tmp21_, "<");
#line 62 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp23_ = g_string_append (_tmp22_, markup_tag);
#line 62 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					g_string_append (_tmp23_, ">");
#line 63 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp24_ = builder;
#line 63 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp25_ = part_markup;
#line 63 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					g_string_append (_tmp24_, _tmp25_);
#line 64 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp26_ = builder;
#line 64 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp27_ = g_string_append (_tmp26_, "</");
#line 64 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp28_ = g_string_append (_tmp27_, markup_tag);
#line 64 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					g_string_append (_tmp28_, ">");
#line 793 "Utilities.c"
				} else {
					GString* _tmp29_;
					const gchar* _tmp30_;
#line 66 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp29_ = builder;
#line 66 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp30_ = part_markup;
#line 66 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					g_string_append (_tmp29_, _tmp30_);
#line 803 "Utilities.c"
				}
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_g_free0 (part_markup);
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_g_free0 (part);
#line 809 "Utilities.c"
			}
		}
#line 55 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 814 "Utilities.c"
	}
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp31_ = builder;
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp32_ = _tmp31_->str;
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp33_;
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_string_free0 (builder);
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_regex_unref0 (regex);
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	regex_words = (_vala_array_free (regex_words, regex_words_length1, (GDestroyNotify) g_free), NULL);
#line 70 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 832 "Utilities.c"
}

gchar*
plotinus_utilities_format_accelerator (const gchar* accelerator)
{
	guint key = 0U;
	GdkModifierType modifiers = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
	gchar* _tmp2_;
	gchar* result;
#line 73 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (accelerator != NULL, NULL);
#line 76 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	gtk_accelerator_parse (accelerator, &_tmp0_, &_tmp1_);
#line 76 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	key = _tmp0_;
#line 76 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	modifiers = _tmp1_;
#line 77 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp2_ = gtk_accelerator_get_label (key, modifiers);
#line 77 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp2_;
#line 77 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 858 "Utilities.c"
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (g_once_init_enter ((volatile gsize*) re)) {
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_once_init_leave ((volatile gsize*) re, (gsize) val);
#line 872 "Utilities.c"
	}
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return *re;
#line 876 "Utilities.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 897 "Utilities.c"
}

gchar*
plotinus_utilities_clean_label (const gchar* label)
{
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 80 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp1_ = g_regex_replace (_thread_safe_regex_init (&_tmp_regex_0, "_(?!_)", 0), label, (gssize) -1, 0, "", 0, &_inner_error0_);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = _tmp1_;
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_clear_error (&_inner_error0_);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return NULL;
#line 922 "Utilities.c"
	}
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp2_ = string_strip (_tmp0_);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp2_;
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_free0 (_tmp0_);
#line 82 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 932 "Utilities.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 89 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return self ? g_object_ref (self) : NULL;
#line 940 "Utilities.c"
}

GtkWidget*
plotinus_utilities_find_widget (GtkContainer* container,
                                GType widget_type)
{
	GList* widgets = NULL;
	GList* _tmp0_;
	GtkWidget* result;
#line 85 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (container != NULL, NULL);
#line 86 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = gtk_container_get_children (container);
#line 86 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	widgets = _tmp0_;
#line 956 "Utilities.c"
	{
		gint i = 0;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		i = 0;
#line 961 "Utilities.c"
		{
			gboolean _tmp1_ = FALSE;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp1_ = TRUE;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			while (TRUE) {
#line 968 "Utilities.c"
				GList* _tmp3_;
				GtkWidget* widget = NULL;
				GList* _tmp4_;
				gconstpointer _tmp5_;
				GtkWidget* _tmp6_;
				GtkWidget* _tmp7_;
				GtkWidget* _tmp8_;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				if (!_tmp1_) {
#line 978 "Utilities.c"
					gint _tmp2_;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp2_ = i;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					i = _tmp2_ + 1;
#line 984 "Utilities.c"
				}
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp1_ = FALSE;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp3_ = widgets;
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				if (!(((guint) i) < g_list_length (_tmp3_))) {
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					break;
#line 994 "Utilities.c"
				}
#line 89 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp4_ = widgets;
#line 89 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp5_ = g_list_nth_data (_tmp4_, (guint) i);
#line 89 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp6_ = _g_object_ref0 ((GtkWidget*) _tmp5_);
#line 89 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				widget = _tmp6_;
#line 91 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp7_ = widget;
#line 91 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				if (!gtk_widget_get_visible (_tmp7_)) {
#line 92 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_g_object_unref0 (widget);
#line 92 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					continue;
#line 1012 "Utilities.c"
				}
#line 94 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_tmp8_ = widget;
#line 94 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				if (g_type_is_a (G_TYPE_FROM_INSTANCE ((GObject*) _tmp8_), widget_type)) {
#line 95 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					result = widget;
#line 95 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					(widgets == NULL) ? NULL : (widgets = (g_list_free (widgets), NULL));
#line 95 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					return result;
#line 1024 "Utilities.c"
				} else {
					GtkWidget* _tmp9_;
#line 96 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp9_ = widget;
#line 96 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, gtk_container_get_type ())) {
#line 1031 "Utilities.c"
						GtkWidget* inner_widget = NULL;
						GtkWidget* _tmp10_;
						GtkWidget* _tmp11_;
						GtkWidget* _tmp12_;
#line 97 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp10_ = widget;
#line 97 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp11_ = plotinus_utilities_find_widget (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp10_) : NULL, widget_type);
#line 97 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						inner_widget = _tmp11_;
#line 98 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp12_ = inner_widget;
#line 98 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						if (_tmp12_ != NULL) {
#line 99 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							result = inner_widget;
#line 99 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_g_object_unref0 (widget);
#line 99 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							(widgets == NULL) ? NULL : (widgets = (g_list_free (widgets), NULL));
#line 99 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							return result;
#line 1054 "Utilities.c"
						}
#line 96 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_g_object_unref0 (inner_widget);
#line 1058 "Utilities.c"
					}
				}
#line 88 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				_g_object_unref0 (widget);
#line 1063 "Utilities.c"
			}
		}
	}
#line 103 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = NULL;
#line 103 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	(widgets == NULL) ? NULL : (widgets = (g_list_free (widgets), NULL));
#line 103 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 1073 "Utilities.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1096 "Utilities.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1105 "Utilities.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1124 "Utilities.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1128 "Utilities.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1134 "Utilities.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1144 "Utilities.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1152 "Utilities.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1156 "Utilities.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 1162 "Utilities.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1172 "Utilities.c"
}

gchar*
plotinus_utilities_get_button_label (GtkButton* button)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GtkLabel* label = NULL;
	GtkWidget* _tmp5_;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	GtkToolButton* tool_button = NULL;
	GtkContainer* _tmp17_;
	GtkContainer* _tmp18_;
	GtkToolButton* _tmp19_;
	GtkToolButton* _tmp20_;
	gchar* name = NULL;
	const gchar* _tmp36_;
	gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* result;
#line 106 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (button != NULL, NULL);
#line 107 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = gtk_button_get_label (button);
#line 107 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp1_ = _tmp0_;
#line 107 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp1_ != NULL) {
#line 1206 "Utilities.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
#line 108 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp2_ = gtk_button_get_label (button);
#line 108 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp3_ = _tmp2_;
#line 108 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp4_ = plotinus_utilities_clean_label (_tmp3_);
#line 108 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = _tmp4_;
#line 108 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 1220 "Utilities.c"
	}
#line 110 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp5_ = plotinus_utilities_find_widget ((GtkContainer*) button, gtk_label_get_type ());
#line 110 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, gtk_label_get_type ()) ? ((GtkLabel*) _tmp5_) : NULL;
#line 110 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp6_ == NULL) {
#line 110 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (_tmp5_);
#line 1230 "Utilities.c"
	}
#line 110 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	label = _tmp6_;
#line 111 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp7_ = label;
#line 111 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp7_ != NULL) {
#line 1238 "Utilities.c"
		GtkLabel* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 112 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp8_ = label;
#line 112 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp9_ = gtk_label_get_text (_tmp8_);
#line 112 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 112 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = _tmp10_;
#line 112 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (label);
#line 112 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 1254 "Utilities.c"
	}
#line 114 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp11_ = gtk_widget_get_tooltip_text ((GtkWidget*) button);
#line 114 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp12_ = _tmp11_;
#line 114 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp13_ = _tmp12_;
#line 114 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp14_ = _tmp13_ != NULL;
#line 114 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_free0 (_tmp13_);
#line 114 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp14_) {
#line 1268 "Utilities.c"
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 115 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp15_ = gtk_widget_get_tooltip_text ((GtkWidget*) button);
#line 115 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp16_ = _tmp15_;
#line 115 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = _tmp16_;
#line 115 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (label);
#line 115 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 1281 "Utilities.c"
	}
#line 117 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp17_ = gtk_widget_get_parent ((GtkWidget*) button);
#line 117 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp18_ = _tmp17_;
#line 117 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, gtk_tool_button_get_type ()) ? ((GtkToolButton*) _tmp18_) : NULL);
#line 117 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	tool_button = _tmp19_;
#line 118 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp20_ = tool_button;
#line 118 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp20_ != NULL) {
#line 1295 "Utilities.c"
		GtkToolButton* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		GtkToolButton* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gboolean _tmp32_;
#line 120 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp21_ = tool_button;
#line 120 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp22_ = gtk_tool_button_get_label (_tmp21_);
#line 120 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp23_ = _tmp22_;
#line 120 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		if (_tmp23_ != NULL) {
#line 1312 "Utilities.c"
			GtkToolButton* _tmp24_;
			const gchar* _tmp25_;
			const gchar* _tmp26_;
			gchar* _tmp27_;
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp24_ = tool_button;
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp25_ = gtk_tool_button_get_label (_tmp24_);
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp26_ = _tmp25_;
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp27_ = plotinus_utilities_clean_label (_tmp26_);
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			result = _tmp27_;
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (tool_button);
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (label);
#line 121 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			return result;
#line 1333 "Utilities.c"
		}
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp28_ = tool_button;
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp29_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp28_);
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp30_ = _tmp29_;
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp31_ = _tmp30_;
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp32_ = _tmp31_ != NULL;
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_free0 (_tmp31_);
#line 123 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		if (_tmp32_) {
#line 1349 "Utilities.c"
			GtkToolButton* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp33_ = tool_button;
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp34_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp33_);
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp35_ = _tmp34_;
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			result = _tmp35_;
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (tool_button);
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (label);
#line 124 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			return result;
#line 1367 "Utilities.c"
		}
	}
#line 127 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp36_ = gtk_buildable_get_name ((GtkBuildable*) button);
#line 127 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp37_ = g_strdup (_tmp36_);
#line 127 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	name = _tmp37_;
#line 128 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp38_ = name;
#line 128 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp38_ != NULL) {
#line 1380 "Utilities.c"
		gchar** name_parts = NULL;
		const gchar* _tmp39_;
		gchar** _tmp40_;
		gchar** _tmp41_;
		gint name_parts_length1;
		gint _name_parts_size_;
		gboolean _tmp42_ = FALSE;
		gchar** _tmp43_;
		gint _tmp43__length1;
#line 130 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp39_ = name;
#line 130 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp41_ = _tmp40_ = g_strsplit (_tmp39_, "_", 0);
#line 130 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		name_parts = _tmp41_;
#line 130 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		name_parts_length1 = _vala_array_length (_tmp40_);
#line 130 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_name_parts_size_ = name_parts_length1;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp43_ = name_parts;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp43__length1 = name_parts_length1;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		if (_tmp43__length1 > 1) {
#line 1406 "Utilities.c"
			gchar** _tmp44_;
			gint _tmp44__length1;
			gchar** _tmp45_;
			gint _tmp45__length1;
			const gchar* _tmp46_;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp44_ = name_parts;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp44__length1 = name_parts_length1;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp45_ = name_parts;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp45__length1 = name_parts_length1;
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp46_ = _tmp44_[_tmp45__length1 - 1];
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp42_ = g_strcmp0 (_tmp46_, "button") == 0;
#line 1424 "Utilities.c"
		} else {
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp42_ = FALSE;
#line 1428 "Utilities.c"
		}
#line 131 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		if (_tmp42_) {
#line 1432 "Utilities.c"
			gchar** _tmp66_;
			gint _tmp66__length1;
			gchar** _tmp67_;
			gint _tmp67__length1;
			gchar* _tmp68_;
			{
				gint i = 0;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
				i = 0;
#line 1442 "Utilities.c"
				{
					gboolean _tmp47_ = FALSE;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					_tmp47_ = TRUE;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
					while (TRUE) {
#line 1449 "Utilities.c"
						gchar** _tmp49_;
						gint _tmp49__length1;
						gchar** _tmp50_;
						gint _tmp50__length1;
						const gchar* _tmp51_;
						gint _tmp52_;
						gint _tmp53_;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						if (!_tmp47_) {
#line 1459 "Utilities.c"
							gint _tmp48_;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp48_ = i;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							i = _tmp48_ + 1;
#line 1465 "Utilities.c"
						}
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp47_ = FALSE;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp49_ = name_parts;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp49__length1 = name_parts_length1;
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						if (!(i < (_tmp49__length1 - 1))) {
#line 132 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							break;
#line 1477 "Utilities.c"
						}
#line 133 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp50_ = name_parts;
#line 133 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp50__length1 = name_parts_length1;
#line 133 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp51_ = _tmp50_[i];
#line 133 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp52_ = strlen (_tmp51_);
#line 133 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						_tmp53_ = _tmp52_;
#line 133 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
						if (_tmp53_ > 1) {
#line 1491 "Utilities.c"
							gchar** _tmp54_;
							gint _tmp54__length1;
							gchar** _tmp55_;
							gint _tmp55__length1;
							const gchar* _tmp56_;
							gchar* _tmp57_;
							gchar* _tmp58_;
							gchar* _tmp59_;
							gchar* _tmp60_;
							gchar** _tmp61_;
							gint _tmp61__length1;
							const gchar* _tmp62_;
							gchar* _tmp63_;
							gchar* _tmp64_;
							gchar* _tmp65_;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp54_ = name_parts;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp54__length1 = name_parts_length1;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp55_ = name_parts;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp55__length1 = name_parts_length1;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp56_ = _tmp55_[i];
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp57_ = string_substring (_tmp56_, (glong) 0, (glong) 1);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp58_ = _tmp57_;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp59_ = g_utf8_strup (_tmp58_, (gssize) -1);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp60_ = _tmp59_;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp61_ = name_parts;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp61__length1 = name_parts_length1;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp62_ = _tmp61_[i];
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp63_ = string_substring (_tmp62_, (glong) 1, (glong) -1);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp64_ = _tmp63_;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_g_free0 (_tmp54_[i]);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_tmp54_[i] = _tmp65_;
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_g_free0 (_tmp64_);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_g_free0 (_tmp60_);
#line 135 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
							_g_free0 (_tmp58_);
#line 1547 "Utilities.c"
						}
					}
				}
			}
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp66_ = name_parts;
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp66__length1 = name_parts_length1;
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp67_ = name_parts;
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp67__length1 = name_parts_length1;
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp68_ = _vala_g_strjoinv (" ", _tmp66_ + 0, (gint) ((_tmp67__length1 - 1) - 0));
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			result = _tmp68_;
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			name_parts = (_vala_array_free (name_parts, name_parts_length1, (GDestroyNotify) g_free), NULL);
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_free0 (name);
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (tool_button);
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (label);
#line 137 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			return result;
#line 1574 "Utilities.c"
		}
#line 128 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		name_parts = (_vala_array_free (name_parts, name_parts_length1, (GDestroyNotify) g_free), NULL);
#line 1578 "Utilities.c"
	}
#line 141 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = NULL;
#line 141 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_free0 (name);
#line 141 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_object_unref0 (tool_button);
#line 141 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_object_unref0 (label);
#line 141 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 1590 "Utilities.c"
}

gchar*
plotinus_utilities_get_window_title (GtkWindow* window)
{
	GtkWidget* titlebar = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkHeaderBar* header_bar = NULL;
	GtkWidget* _tmp6_;
	GtkHeaderBar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkHeaderBar* _tmp9_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GtkHeaderBar* _tmp16_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* result;
#line 144 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 145 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = gtk_window_get_titlebar (window);
#line 145 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 145 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	titlebar = _tmp1_;
#line 146 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp2_ = titlebar;
#line 146 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp2_ == NULL) {
#line 1624 "Utilities.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 147 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp3_ = gtk_window_get_title (window);
#line 147 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp4_ = _tmp3_;
#line 147 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 147 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = _tmp5_;
#line 147 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (titlebar);
#line 147 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 1640 "Utilities.c"
	}
#line 149 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp6_ = titlebar;
#line 149 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gtk_header_bar_get_type ()) ? ((GtkHeaderBar*) _tmp6_) : NULL);
#line 149 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	header_bar = _tmp7_;
#line 150 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp9_ = header_bar;
#line 150 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp9_ == NULL) {
#line 1652 "Utilities.c"
		GtkWidget* _tmp10_;
#line 150 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp10_ = titlebar;
#line 150 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_container_get_type ());
#line 1658 "Utilities.c"
	} else {
#line 150 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp8_ = FALSE;
#line 1662 "Utilities.c"
	}
#line 150 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp8_) {
#line 1666 "Utilities.c"
		GtkWidget* _tmp11_;
		GtkWidget* _tmp12_;
		GtkHeaderBar* _tmp13_;
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp11_ = titlebar;
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp12_ = plotinus_utilities_find_widget (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp11_) : NULL, gtk_header_bar_get_type ());
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp13_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_header_bar_get_type ()) ? ((GtkHeaderBar*) _tmp12_) : NULL;
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		if (_tmp13_ == NULL) {
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_g_object_unref0 (_tmp12_);
#line 1680 "Utilities.c"
		}
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (header_bar);
#line 152 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		header_bar = _tmp13_;
#line 1686 "Utilities.c"
	}
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp16_ = header_bar;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp16_ != NULL) {
#line 1692 "Utilities.c"
		GtkHeaderBar* _tmp17_;
		GtkWidget* _tmp18_;
		GtkWidget* _tmp19_;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp17_ = header_bar;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp18_ = gtk_header_bar_get_custom_title (_tmp17_);
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp19_ = _tmp18_;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp15_ = _tmp19_ == NULL;
#line 1704 "Utilities.c"
	} else {
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp15_ = FALSE;
#line 1708 "Utilities.c"
	}
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp15_) {
#line 1712 "Utilities.c"
		GtkHeaderBar* _tmp20_;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp20_ = header_bar;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp21_ = gtk_header_bar_get_title (_tmp20_);
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp22_ = _tmp21_;
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp14_ = _tmp22_ != NULL;
#line 1724 "Utilities.c"
	} else {
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp14_ = FALSE;
#line 1728 "Utilities.c"
	}
#line 154 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp14_) {
#line 1732 "Utilities.c"
		GtkHeaderBar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp23_ = header_bar;
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp24_ = gtk_header_bar_get_title (_tmp23_);
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp25_ = _tmp24_;
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp26_ = g_strdup (_tmp25_);
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = _tmp26_;
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (header_bar);
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_g_object_unref0 (titlebar);
#line 155 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 1753 "Utilities.c"
	}
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp27_ = gtk_window_get_title (window);
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp28_ = _tmp27_;
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp29_;
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_object_unref0 (header_bar);
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_g_object_unref0 (titlebar);
#line 157 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 1769 "Utilities.c"
}

static Block15Data*
block15_data_ref (Block15Data* _data15_)
{
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_atomic_int_inc (&_data15_->_ref_count_);
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return _data15_;
#line 1779 "Utilities.c"
}

static void
block15_data_unref (void * _userdata_)
{
	Block15Data* _data15_;
	_data15_ = (Block15Data*) _userdata_;
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (g_atomic_int_dec_and_test (&_data15_->_ref_count_)) {
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_data15_->windows = (_vala_array_free (_data15_->windows, _data15_->windows_length1, (GDestroyNotify) g_object_unref), NULL);
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_slice_free (Block15Data, _data15_);
#line 1793 "Utilities.c"
	}
}

static void
_vala_array_add24 (GtkWindow** * array,
                   gint* length,
                   gint* size,
                   GtkWindow* value)
{
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if ((*length) == (*size)) {
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		*array = g_renew (GtkWindow*, *array, (*size) + 1);
#line 1809 "Utilities.c"
	}
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	(*array)[(*length)++] = value;
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	(*array)[*length] = NULL;
#line 1815 "Utilities.c"
}

static void
__lambda18_ (Block15Data* _data15_,
             GtkWindow* window)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 163 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_return_if_fail (window != NULL);
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (!PLOTINUS_IS_POPUP_WINDOW (window)) {
#line 1828 "Utilities.c"
		GtkWindowType _tmp2_;
		GtkWindowType _tmp3_;
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		g_object_get (window, "type", &_tmp2_, NULL);
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp3_ = _tmp2_;
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp1_ = _tmp3_ == GTK_WINDOW_TOPLEVEL;
#line 1837 "Utilities.c"
	} else {
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp1_ = FALSE;
#line 1841 "Utilities.c"
	}
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp1_) {
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp0_ = gtk_widget_is_visible ((GtkWidget*) window);
#line 1847 "Utilities.c"
	} else {
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp0_ = FALSE;
#line 1851 "Utilities.c"
	}
#line 164 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (_tmp0_) {
#line 1855 "Utilities.c"
		GtkWindow* _tmp4_;
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_tmp4_ = _g_object_ref0 (window);
#line 165 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		_vala_array_add24 (&_data15_->windows, &_data15_->windows_length1, &_data15_->_windows_size_, _tmp4_);
#line 1861 "Utilities.c"
	}
}

static void
___lambda18__gfunc (gconstpointer data,
                    gpointer self)
{
#line 163 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	__lambda18_ (self, (GtkWindow*) data);
#line 1871 "Utilities.c"
}

static GtkWindow**
_vala_array_dup13 (GtkWindow** self,
                   gssize length)
{
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (length >= 0) {
#line 1880 "Utilities.c"
		GtkWindow** result;
		gssize i;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		result = g_new0 (GtkWindow*, length + 1);
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		for (i = 0; i < length; i++) {
#line 1887 "Utilities.c"
			GtkWindow* _tmp0_;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
			result[i] = _tmp0_;
#line 1893 "Utilities.c"
		}
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		return result;
#line 1897 "Utilities.c"
	}
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return NULL;
#line 1901 "Utilities.c"
}

GtkWindow**
plotinus_utilities_get_windows (gint* result_length1)
{
	Block15Data* _data15_;
	GtkWindow** _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GtkWindow** _tmp3_;
	gint _tmp3__length1;
	GtkWindow** _tmp4_;
	gint _tmp4__length1;
	GtkWindow** result;
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_data15_ = g_slice_new0 (Block15Data);
#line 160 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_data15_->_ref_count_ = 1;
#line 161 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp0_ = g_new0 (GtkWindow*, 0 + 1);
#line 161 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_data15_->windows = _tmp0_;
#line 161 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_data15_->windows_length1 = 0;
#line 161 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_data15_->_windows_size_ = _data15_->windows_length1;
#line 163 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp1_ = gtk_window_list_toplevels ();
#line 163 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp2_ = _tmp1_;
#line 163 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	g_list_foreach (_tmp2_, ___lambda18__gfunc, _data15_);
#line 163 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp3_ = (_data15_->windows != NULL) ? _vala_array_dup13 (_data15_->windows, _data15_->windows_length1) : _data15_->windows;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp3__length1 = _data15_->windows_length1;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp4_ = _tmp3_;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_tmp4__length1 = _tmp3__length1;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	if (result_length1) {
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
		*result_length1 = _tmp4__length1;
#line 1948 "Utilities.c"
	}
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	result = _tmp4_;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	block15_data_unref (_data15_);
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	_data15_ = NULL;
#line 168 "/builddir/build/BUILD/plotinus-0.2.0-build/plotinus-c51aa596b4f92ec98baad4e20c659592369527a3/src/Utilities.vala"
	return result;
#line 1958 "Utilities.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

